Attribute VB_Name = "SentenceLengthColorizer"
Option Base 1

Sub Colorize()
    
    ' The number of different sentence-length-based categories/colors
    Const catCount As Long = 7
    
    ' The list of word counts defining the sentence-length categories
    Dim wordCounts(catCount - 1) As Long
    
    ' Word counts assignment
    wordCounts(1) = 3
    wordCounts(2) = 5
    wordCounts(3) = 10
    wordCounts(4) = 20
    wordCounts(5) = 30
    wordCounts(6) = 50
    
    ' The list of colors matching the word counts
    ' Note that it has one element more than the list of word counts
    Dim sntcColors(catCount) As Long
    
    ' Color assignment
    ' The last element is the color you want to see on sentences longer
    ' than the largest count in word-count list
    sntcColors(1) = RGB(255, 255, 143)
    sntcColors(2) = RGB(248, 142, 134)
    sntcColors(3) = RGB(255, 216, 223)
    sntcColors(4) = RGB(180, 237, 123)
    sntcColors(5) = RGB(255, 211, 144)
    sntcColors(6) = RGB(237, 216, 255)
    sntcColors(7) = RGB(156, 255, 255)
    
    Dim sntcColorInd As Long
   
    For Each sntc In Selection.Sentences
        With sntc
            sntcColorInd = catCount
            For ind = 1 To catCount - 1
                If .Words.Count <= wordCounts(ind) Then
                    sntcColorInd = ind
                    Exit For
                End If
            Next
            With .Font.Shading
                .Texture = wdTextureNone
                .ForegroundPatternColor = wdColorAutomatic
                .BackgroundPatternColor = sntcColors(sntcColorInd)
            End With
        End With
    Next
   
End Sub

Sub Uncolorize()
    Selection.Font.Shading.BackgroundPatternColorIndex = wdAuto
End Sub

